## com.fasterxml.jackson.databind.node
Class ObjectNode

    java.lang.Object
      com.fasterxml.jackson.databind.JsonNode
          com.fasterxml.jackson.databind.node.BaseJsonNode
              com.fasterxml.jackson.databind.node.ContainerNode<ObjectNode>
                  com.fasterxml.jackson.databind.node.ObjectNode

All Implemented Interfaces:
  TreeNode, JsonSerializable, Iterable<JsonNode>

    public class ObjectNode

extends ContainerNode<ObjectNode>

Node that maps to JSON Object structures in JSON content.

Nested Class Summary
`protected static class` `ObjectNode.NoFieldsIterator` For efficiency, let's share the "no fields" iterator...

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`ContainerNode.NoNodesIterator, ContainerNode.NoStringsIterator`

Field Summary
`protected LinkedHashMap<String,JsonNode>` `_children`

Fields inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`_nodeFactory`

Fields inherited from class com.fasterxml.jackson.databind.JsonNode
`NO_NODES, NO_STRINGS`

Constructor Summary
`` `ObjectNode(JsonNodeFactory nc)`
`protected` `ObjectNode(JsonNodeFactory nc, LinkedHashMap<String,JsonNode> children)`

Method Summary
`JsonToken` `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
`ObjectNode` `deepCopy()` Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children.
`Iterator<JsonNode>` `elements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
`boolean` `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
`Iterator<String>` `fieldNames()` Method for accessing names of all fields for this Node, iff this node is a JSON Object node.
`Iterator<Map.Entry<String,JsonNode>>` `fields()` Method to use for accessing all fields (with both names and values) of this JSON Object.
`ObjectNode` `findParent(String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
`List<JsonNode>` `findParents(String fieldName, List<JsonNode> foundSoFar)`
`JsonNode` `findValue(String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
`List<JsonNode>` `findValues(String fieldName, List<JsonNode> foundSoFar)`
`List<String>` `findValuesAsText(String fieldName, List<String> foundSoFar)`
`JsonNode` `get(int index)` Method for accessing value of the specified element of an array node.
`JsonNode` `get(String fieldName)` Method for accessing value of the specified field of an object node.
`int` `hashCode()`
`boolean` `isObject()`
`JsonNode` `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`JsonNode` `path(String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`ObjectNode` `put(String fieldName, BigDecimal v)` Method for setting value of a field to specified numeric value.
`ObjectNode` `put(String fieldName, boolean v)` Method for setting value of a field to specified String value.
`ObjectNode` `put(String fieldName, Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ObjectNode` `put(String fieldName, byte[] v)` Method for setting value of a field to specified binary value
`ObjectNode` `put(String fieldName, double v)` Method for setting value of a field to specified numeric value.
`ObjectNode` `put(String fieldName, Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ObjectNode` `put(String fieldName, float v)` Method for setting value of a field to specified numeric value.
`ObjectNode` `put(String fieldName, Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ObjectNode` `put(String fieldName, int v)` Method for setting value of a field to specified numeric value.
`ObjectNode` `put(String fieldName, Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`JsonNode` `put(String fieldName, JsonNode value)` Method that will set specified field, replacing old value, if any.
`ObjectNode` `put(String fieldName, long v)` Method for setting value of a field to specified numeric value.
`ObjectNode` `put(String fieldName, Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ObjectNode` `put(String fieldName, String v)` Method for setting value of a field to specified String value.
`JsonNode` `putAll(Map<String,JsonNode> properties)` Method for adding given properties to this object node, overriding any existing values for those properties.
`JsonNode` `putAll(ObjectNode other)` Method for adding all properties of the given Object, overriding any existing values for those properties.
`ArrayNode` `putArray(String fieldName)` Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
`protected void` `putContentsTo(Map<String,JsonNode> dst)`
`ObjectNode` `putNull(String fieldName)`
`ObjectNode` `putObject(String fieldName)` Method that will construct an ObjectNode and add it as a field of this ObjectNode, replacing old value, if any.
`ObjectNode` `putPOJO(String fieldName, Object pojo)`
`ObjectNode` `remove(Collection<String> fieldNames)` Method for removing specified field properties out of this ObjectNode.
`JsonNode` `remove(String fieldName)` Method for removing field entry from this ObjectNode.
`ObjectNode` `removeAll()` Method for removing all field properties, such that this ObjectNode will contain no properties after call.
`ObjectNode` `retain(Collection<String> fieldNames)` Method for removing all field properties out of this ObjectNode except for ones specified in argument.
`ObjectNode` `retain(String... fieldNames)` Method for removing all field properties out of this ObjectNode except for ones specified in argument.
`void` `serialize(JsonGenerator jg, SerializerProvider provider)` Method that can be called to serialize this node and all of its descendants using specified JSON generator.
`void` `serializeWithType(JsonGenerator jg, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
`int` `size()` Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.
`String` `toString()` Note: marked as abstract to ensure all implementation classes define it properly.
`ObjectNode` `with(String propertyName)` Method that can be called on Object nodes, to access a property that has Object value; or if no such property exists, to create, add and return such Object node.
`ArrayNode` `withArray(String propertyName)` Method that can be called on Object nodes, to access a property that has `Array` value; or if no such property exists, to create, add and return such Array node.

Methods inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`arrayNode, asText, binaryNode, binaryNode, booleanNode, isContainerNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, POJONode, textNode`

Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode
`findPath, numberType, traverse`

Methods inherited from class com.fasterxml.jackson.databind.JsonNode

`asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, bigIntegerValue, binaryValue, booleanValue, canConvertToInt, canConvertToLong, decimalValue, doubleValue, findParents, findValues, findValuesAsText, has, has, intValue, isArray, isBigDecimal, isBigInteger, isBinary, isBoolean, isDouble, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isPojo, isTextual, isValueNode, iterator, longValue, numberValue, textValue`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### _children

    protected LinkedHashMap<String,JsonNode> _children

Constructor Detail

### ObjectNode

    public ObjectNode(JsonNodeFactory nc)

### ObjectNode

    protected ObjectNode(JsonNodeFactory nc,
                         LinkedHashMap<String,JsonNode> children)

Method Detail

### deepCopy

    public ObjectNode deepCopy()

  Description copied from class: `JsonNode`
  Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children. This means it can either make a copy of this node (and all mutable children and grand children nodes), or node itself if it is immutable.

  Note: return type is guaranteed to have same type as the node method is called on; which is why method is declared with local generic type.

  Specified by:
    `deepCopy` in class `JsonNode`
  Returns:
    Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

### asToken

    public JsonToken asToken()

  Description copied from class: `BaseJsonNode`
  Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)

  Specified by:
    `asToken` in interface `TreeNode`
  Specified by:
    `asToken` in class `ContainerNode<ObjectNode>`

### isObject

    public boolean isObject()

  Overrides:
    `isObject` in class `JsonNode`
  Returns:
    True if this node represents JSON Object

### size

    public int size()

  Description copied from class: `JsonNode`
  Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.

  Specified by:
    `size` in class `ContainerNode<ObjectNode>`
  Returns:
    For non-container nodes returns 0; for arrays number of contained elements, and for objects number of fields.

### elements

    public Iterator<JsonNode> elements()

  Description copied from class: `JsonNode`
  Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.

  Overrides:
    `elements` in class `JsonNode`

### get

    public JsonNode get(int index)

  Description copied from class: `JsonNode`
  Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

  For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

  Specified by:
    `get` in class `ContainerNode<ObjectNode>`
  Returns:
    Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

### get

    public JsonNode get(String fieldName)

  Description copied from class: `JsonNode`
  Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.

  Specified by:
    `get` in class `ContainerNode<ObjectNode>`
  Returns:
    Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

### fieldNames

    public Iterator<String> fieldNames()

  Description copied from class: `JsonNode`
  Method for accessing names of all fields for this Node, iff this node is a JSON Object node.

  Overrides:
    `fieldNames` in class `JsonNode`

### path

    public JsonNode path(int index)

  Description copied from class: `JsonNode`
  This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

  Specified by:
    `path` in class `JsonNode`

### path

    public JsonNode path(String fieldName)

  Description copied from class: `JsonNode`
  This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

  Specified by:
    `path` in class `JsonNode`

### fields

    public Iterator<Map.Entry<String,JsonNode>> fields()

  Method to use for accessing all fields (with both names and values) of this JSON Object.

  Overrides:
    `fields` in class `JsonNode`
  Returns:
    Iterator that can be used to traverse all key/value pairs for object nodes; empty iterator (no contents) for other types

### with

    public ObjectNode with(String propertyName)

  Description copied from class: `JsonNode`
  Method that can be called on Object nodes, to access a property that has Object value; or if no such property exists, to create, add and return such Object node. If the node method is called on is not Object node, or if property exists and has value that is not Object node, `UnsupportedOperationException` is thrown

  Overrides:
    `with` in class `JsonNode`

### withArray

    public ArrayNode withArray(String propertyName)

  Description copied from class: `JsonNode`
  Method that can be called on Object nodes, to access a property that has `Array` value; or if no such property exists, to create, add and return such Array node. If the node method is called on is not Object node, or if property exists and has value that is not Array node, `UnsupportedOperationException` is thrown

  Overrides:
    `withArray` in class `JsonNode`

### findValue

    public JsonNode findValue(String fieldName)

  Description copied from class: `JsonNode`
  Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.

  Specified by:
    `findValue` in class `ContainerNode<ObjectNode>`
  Parameters:
    `fieldName` - Name of field to look for
  Returns:
    Value of first matching node found, if any; null if none

### findValues

    public List<JsonNode> findValues(String fieldName,
                                     List<JsonNode> foundSoFar)

  Specified by:
    `findValues` in class `ContainerNode<ObjectNode>`

### findValuesAsText

    public List<String> findValuesAsText(String fieldName,
                                         List<String> foundSoFar)

  Specified by:
    `findValuesAsText` in class `ContainerNode<ObjectNode>`

### findParent

    public ObjectNode findParent(String fieldName)

  Description copied from class: `JsonNode`
  Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.

  Specified by:
    `findParent` in class `ContainerNode<ObjectNode>`
  Parameters:
    `fieldName` - Name of field to look for
  Returns:
    Value of first matching node found, if any; null if none

### findParents

    public List<JsonNode> findParents(String fieldName,
                                      List<JsonNode> foundSoFar)

  Specified by:
    `findParents` in class `ContainerNode<ObjectNode>`

### serialize

    public final void serialize(JsonGenerator jg,
                                SerializerProvider provider)
                         throws IOException,
                                JsonProcessingException

  Method that can be called to serialize this node and all of its descendants using specified JSON generator.

  Specified by:
    `serialize` in interface `JsonSerializable`
  Specified by:
    `serialize` in class `BaseJsonNode`
  Throws:
    `IOException`
    `JsonProcessingException`

### serializeWithType

    public void serializeWithType(JsonGenerator jg,
                                  SerializerProvider provider,
                                  TypeSerializer typeSer)
                           throws IOException,
                                  JsonProcessingException

  Description copied from class: `BaseJsonNode`
  Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.

  Specified by:
    `serializeWithType` in interface `JsonSerializable`
  Specified by:
    `serializeWithType` in class `BaseJsonNode`
  Throws:
    `IOException`
    `JsonProcessingException`

### put

    public JsonNode put(String fieldName,
                        JsonNode value)

  Method that will set specified field, replacing old value, if any.

  Parameters:
    `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(java.lang.String)` instead)
  Returns:
    Old value of the field, if any; null if there was no old value.

### remove

    public JsonNode remove(String fieldName)

  Method for removing field entry from this ObjectNode. Will return value of the field, if such field existed; null if not.

### remove

    public ObjectNode remove(Collection<String> fieldNames)

  Method for removing specified field properties out of this ObjectNode.

  Parameters:
    `fieldNames` - Names of fields to remove
  Returns:
    This ObjectNode after removing entries

### removeAll

    public ObjectNode removeAll()

  Method for removing all field properties, such that this ObjectNode will contain no properties after call.

  Specified by:
    `removeAll` in class `ContainerNode<ObjectNode>`
  Returns:
    Container node itself (to allow method call chaining)

### putAll

    public JsonNode putAll(Map<String,JsonNode> properties)

  Method for adding given properties to this object node, overriding any existing values for those properties.

  Parameters:
    `properties` - Properties to add
  Returns:
    This node (to allow chaining)

### putAll

    public JsonNode putAll(ObjectNode other)

  Method for adding all properties of the given Object, overriding any existing values for those properties.

  Parameters:
    `other` - Object of which properties to add to this object
  Returns:
    This node (to allow chaining)

### retain

    public ObjectNode retain(Collection<String> fieldNames)

  Method for removing all field properties out of this ObjectNode except for ones specified in argument.

  Parameters:
    `fieldNames` - Fields to retain in this ObjectNode
  Returns:
    This ObjectNode (to allow call chaining)

### retain

    public ObjectNode retain(String... fieldNames)

  Method for removing all field properties out of this ObjectNode except for ones specified in argument.

  Parameters:
    `fieldNames` - Fields to retain in this ObjectNode
  Returns:
    This ObjectNode (to allow call chaining)

### putArray

    public ArrayNode putArray(String fieldName)

  Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.

  Returns:
    Newly constructed ArrayNode (NOT the old value, which could be of any type)

### putObject

    public ObjectNode putObject(String fieldName)

  Method that will construct an ObjectNode and add it as a field of this ObjectNode, replacing old value, if any.

  Returns:
    Newly constructed ObjectNode (NOT the old value, which could be of any type)

### putPOJO

    public ObjectNode putPOJO(String fieldName,
                              Object pojo)

### putNull

    public ObjectNode putNull(String fieldName)

### put

    public ObjectNode put(String fieldName,
                          int v)

  Method for setting value of a field to specified numeric value.

### put

    public ObjectNode put(String fieldName,
                          Integer value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

### put

    public ObjectNode put(String fieldName,
                          long v)

  Method for setting value of a field to specified numeric value.

### put

    public ObjectNode put(String fieldName,
                          Long value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

### put

    public ObjectNode put(String fieldName,
                          float v)

  Method for setting value of a field to specified numeric value.

### put

    public ObjectNode put(String fieldName,
                          Float value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

### put

    public ObjectNode put(String fieldName,
                          double v)

  Method for setting value of a field to specified numeric value.

### put

    public ObjectNode put(String fieldName,
                          Double value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

### put

    public ObjectNode put(String fieldName,
                          BigDecimal v)

  Method for setting value of a field to specified numeric value.

### put

    public ObjectNode put(String fieldName,
                          String v)

  Method for setting value of a field to specified String value.

### put

    public ObjectNode put(String fieldName,
                          boolean v)

  Method for setting value of a field to specified String value.

### put

    public ObjectNode put(String fieldName,
                          Boolean value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

### put

    public ObjectNode put(String fieldName,
                          byte[] v)

  Method for setting value of a field to specified binary value

### putContentsTo

    protected void putContentsTo(Map<String,JsonNode> dst)

### equals

    public boolean equals(Object o)

  Description copied from class: `JsonNode`
  Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

  Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

  Specified by:
    `equals` in class `JsonNode`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Description copied from class: `JsonNode`

  Note: marked as abstract to ensure all implementation classes define it properly.

  Specified by:
    `toString` in class `JsonNode`

Copyright © 2012 fasterxml.com. All Rights Reserved.